package NotepadServer {
	function GameConnection::autoAdminCheck(%this) {
		Parent::autoAdminCheck(%this);
		commandToClient(%this,'NotepadHandshake',%this.isSuperAdmin);
	}
};
activatePackage(NotepadServer);
function serverCmdNotepadloadFiles(%cl,%directory) {
	if(!%cl.isSuperAdmin) return;
	%code = getNonsense();
	%cl.notepadLoadCode = %code;
	commandToClient(%cl,'NotepadClear',%cl.NPTicket,1);
	if(trim(%directory) !$= "") if(getSubStr(%directory,strLen(%directory)-1,1) !$= "/") %directory = %directory@"/";
	if(trim(%directory) !$= "") commandToClient(%cl,'NotepadReceiveFile',%cl.NPTicket,"..",%directory);
	for(%file = findFirstFile(%directory@"*");%file !$= ""; %file = findNextFile(%directory@"*")) {
		// we're getting folders here, boy
		%found = 0;
		%path = filePath(%file);
		%pathchk = strReplace(%path,%directory,"");
		%pathchk = strReplace(%pathChk,"/",""TAB"");
		if(getFieldCount(%pathchk) != 1) continue;
		if(%found) continue;
		if(trim(%path) $= "") continue;
		if(%cl.notepadLoadCode !$= %code) return;
		commandToClient(%cl,'NotepadReceiveFile',%cl.NPTicket,%path,%directory);
	}
	%allowedFiles = "_.txt_.cs_";
	for(%file = findFirstFile( %directory@"*.*" );%file !$= ""; %file = findNextFile(%directory@"*.*")) {
		if(stripos(%allowedFiles,"_"@fileExt(%file)@"_") == -1) continue;
		if(filePath(%file)@"/" !$= %directory) continue;
		if(fileExt(%file) $= "") continue;
		if(%cl.notepadLoadCode !$= %code) return;
		commandToClient(%cl,'NotepadReceiveFile',%cl.NPTicket,%file,%directory);
	}
}
function serverCmdNotepadOpenFile(%cl,%file) {
	if(!%cl.isSuperAdmin) return;
	commandToClient(%cl,'NotepadClear',%cl.NPTicket,1);
	%path = filePath(%file);
	%file = fileName(%file);
	if(%path !$= "") %path = %path@"/";
	if(%file $= "..") {
		if(trim(%path) $= "") return;
		%patha = strReplace(%path,"/",""TAB"");
		for(%i=0;%i<getFieldCount(%patha)-1;%i++) %pathb = %pathb@"/"@getField(%patha,%i);
		if(trim(%pathb) !$= "") %pathb = getSubStr(%pathb,1,strLen(%pathb)-1);
		serverCmdNotepadloadFiles(%cl,%pathb);
		return;

	}
	if(fileExt(%file) $= "") {
		serverCmdNotepadLoadFiles(%cl,%file);
		return;
	}
	if(!isFile(%path@%file)) {
		commandToClient(%cl,'MessageBoxOk',"Error","The file you requested does not exist.");
		return;
	}
	commandToClient(%cl,'NotepadClear',%cl.NPTicket,0);
	%SO = new FileObject();
	%SO.openForRead(%path@%file);
	while(!%SO.isEOF()) {
		%strLine = %SO.readLine();
		%strLine = strReplace(%strLine,""TAB"","<tab>");
		commandToClient(%cl,'NotepadReceiveData',%cl.NPTicket,%strLine);
	}
	%SO.close();
	%SO.delete();
	commandToClient(%cl,'NotepadDoneFile',%cl.NPTicket,fileName(%file),%path@%file);
}
function serverCmdNotepadRunFile(%cl,%file) {
	if(!%cl.isSuperAdmin) return;
	%file = %cl.notepadFile;
	messageAll('MsgAdminForce',"\c3"@%cl.getPlayerName()@"\c2 (ID:"@%cl.getBLID()@") modified & executed a file ("@%file@").");
	echo(%cl.getPlayerName()@" BLID:"@%cl.getBLID()@", IP:"@%cl.getRawIP()@" modified and executed a file ("@%file@").");
	exec(%file);
}
function serverCmdNotepadEval(%cl,%str) {
	if(!%cl.isSuperAdmin) return;
	switch$(firstWord(%str)) {
		case "START":
			%cl.notepadCode = "";
		case "END":
			messageAll('MsgAdminForce',"\c3"@%cl.getPlayerName()@"\c2 (ID:"@%cl.getBLID()@") EVAL:<br>"@%cl.notepadCode);
			echo(%cl.getPlayerName()@" BLID:"@%cl.getBLID()@", IP:"@%cl.getRawIP()@" EVAL:");
			echo(%cl.notepadCode);
			echo("---");
			eval(%cl.notepadCode);
		default:
			%dontstop = 1;
	}
	if(!%dontStop) return;
	%cl.notepadCode = %cl.notepadCode @ %str;
}
function serverCmdNotepadSave(%cl,%str,%file) {
	if(!%cl.isSuperAdmin) return;
	if(firstWord(%str) $= "START") {
		if(isObject($Server::SO)) return;
		$Server::SO = new FileObject();
		$Server::SO.openForWrite(%file);
		%cl.notepadFile = %file;
		return;
	}
	if(firstWord(%str) $= "END") {
		$Server::SO.close();
		$Server::SO.delete();
		commandToClient(%cl,'CloseNotepadFS',%cl.NPTicket);
		commandToClient(%cl,'messageboxok',"","Finished saving file.");
		if(fileExt(%cl.notepadFile) $= ".cs") commandToClient(%cl,'messageBoxYesNo',"Notepad","Execute this file?",'notepadRunFile');
		return;
	}
	if(!isObject($Server::SO)) return;
	$Server::SO.writeLine(%str);
}
function serverCmdNotepadHS(%cl,%ticket) {
	%cl.NPTicket = %ticket;
}
function serverCmdNotepadDeleteFile(%cl,%file) {
	echo(%cl SPC %file);
	if(!%cl.isSuperAdmin) return;
	if(%file $= "" || fileExt(%file) $= "") {
		commandToClient(%cl,'messageBoxOk',"Error - Notepad","You can only delete files.");
		return;
	}
	if(!isFile(%file)) {
		commandToClient(%cl,'messageboxok',"Error - Notepad","This file does not exist and cannot be deleted.");
		return;
	}
	fileDelete(%file);
	setModPaths(getModPaths());
	serverCmdNotepadloadFiles(%cl,filePath(%file));
	messageBoxOk("Notepad","Deleted file.");
}